LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY RESETCONT IS
	PORT
	(
		B_DATA	: IN 	STD_LOGIC;
		RE_X	: IN	STD_LOGIC;
		RE_Y	: IN	STD_LOGIC;
		RE_Z	: IN	STD_LOGIC;
		B_IOWN	: IN	STD_LOGIC;
		X_RESET	: OUT	STD_LOGIC;
		Y_RESET	: OUT	STD_LOGIC;
		Z_RESET	: OUT	STD_LOGIC);
END RESETCONT;

ARCHITECTURE RTL OF RESETCONT IS
	SIGNAL	WRITE_X: STD_LOGIC;
	SIGNAL	WRITE_Y: STD_LOGIC;
	SIGNAL	WRITE_Z: STD_LOGIC;
BEGIN
WRITE_X <= RE_X and not B_IOWN;
WRITE_Y <= RE_Y and not B_IOWN;
WRITE_Z <= RE_Z and not B_IOWN;
process(WRITE_X,WRITE_Y,WRITE_Z)
	begin
			if (WRITE_X='1') then
				X_RESET <= B_DATA;
			else
				X_RESET <= '0';
			end if;
			if (WRITE_Y='1') then
				Y_RESET <= B_DATA;
			else
				Y_RESET <= '0';
			end if;
			if (WRITE_Z='1') then
				Z_RESET <= B_DATA;
			else
				Z_RESET <= '0';
			end if;
	end process;
END RTL;




